# -*- coding: utf-8 -*-
# Generated by Django 1.10.2 on 2017-08-17 10:44
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion
import taggit.managers


class Migration(migrations.Migration):

    dependencies = [
        ('contenttypes', '0002_remove_content_type_name'),
        ('ddusers', '0092_delete_datatypenew'),
    ]

    operations = [
        migrations.CreateModel(
            name='DataSetDescription',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('creator', models.CharField(max_length=400)),
                ('publication_date', models.DateField(auto_now_add=True)),
                ('date_of_data_creation', models.DateField(blank=True, null=True)),
                ('date_of_data_creation_text', models.CharField(max_length=400)),
                ('version', models.DecimalField(decimal_places=1, default=1.0, max_digits=5)),
                ('description', models.TextField()),
                ('countries', models.ManyToManyField(blank=True, related_name='datasetdescription_country', to='ddusers.Country')),
                ('dataset', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='datasetdescription_dataset_dataset', to='ddusers.DataSet')),
            ],
        ),
        migrations.CreateModel(
            name='KeywordTagged',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100, unique=True, verbose_name='Name')),
                ('slug', models.SlugField(max_length=100, unique=True, verbose_name='Slug')),
            ],
            options={
                'verbose_name_plural': 'Keyword Tags',
                'verbose_name': 'Keyword Tag',
            },
        ),
        migrations.CreateModel(
            name='KeywordTags',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('object_id', models.IntegerField(db_index=True, verbose_name='Object id')),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='ddusers_keywordtags_tagged_items', to='contenttypes.ContentType', verbose_name='Content type')),
                ('tag', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='keywordtags_keywordtagged', to='ddusers.KeywordTagged')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AlterField(
            model_name='user',
            name='interests',
            field=taggit.managers.TaggableManager(blank=True, help_text='A comma-separated list of tags.', through='ddusers.KeywordTags', to='ddusers.KeywordTagged', verbose_name='Tags'),
        ),
        migrations.AddField(
            model_name='datasetdescription',
            name='keyword_tags',
            field=taggit.managers.TaggableManager(blank=True, help_text='A comma-separated list of tags.', through='ddusers.KeywordTags', to='ddusers.KeywordTagged', verbose_name='Tags'),
        ),
    ]
